---------------------------------------------------
---------------------------------------------------
--  Easy 1 Processor Architecture				 --
--  University of Puerto Rico					 --
--  Mayaguez Campus								 --
--	Department of Computer Engineering			 --
-- 												 --
--	Copyright (c) 2003							 --
--	All rigths reserved.						 --
--										   		 --
--	Prof. Bienvenido Vlez						 --
--	Abdiel Avils								 --
--	Rafael S. Garca							 --
--	Nesmary Hernndez 							 --
-- 	Carlos Prez								 --
---------------------------------------------------
---------------------------------------------------
-- 	[easy1_add.vhd]
--	Easy 1 Adder
--	This module describes the Easy 1 Adder.
--	The Easy 1 Adder receives two operands in two's
--	complement logic and adds them. The result and
--	carry out are outputs.
---------------------------------------------------	
---------------------------------------------------
--	Libraries declarations
library ieee;
use ieee.std_logic_1164.all;
use easy1_package.all;
--
---------------------------------------------------
--	Entity declaration
--	@a        	- operand from the A Bus
--	@b        	- operand from the Accumulator
--	@sum		- result
--	@cout		- carry out
--					 
entity easy1_add is
	
	port (
		a    : in  std_logic_vector(15 downto 0):=X"0000";
		b    : in  std_logic_vector(15 downto 0):=X"0000";
		sum  : out std_logic_vector(15 downto 0):=X"0000";
		cout : out std_logic:='0');
	
end easy1_add;
--
----------------------------------------------------
--	Architecture declaration
--	Signals :
--		@coutn			- signal that connects the carry out
--						  bit to the carry in bit
--
--	Components :
--		@easy1_one_bit_adder	- one bit adder
--
architecture arq of easy1_add is

	component easy1_one_bit_adder
		port(
		abit 	 : in  std_logic:='0';
		bbit 	 : in  std_logic:='0';
		cinbit 	 : in  std_logic:='0';
		coutbit  : out std_logic:='0';
		sumbit 	 : out std_logic:='0');
	end component;
	
	signal cout0 : std_logic:='0';
	signal cout1 : std_logic:='0';
	signal cout2 : std_logic:='0';
	signal cout3 : std_logic:='0';
	signal cout4 : std_logic:='0';
	signal cout5 : std_logic:='0';
	signal cout6 : std_logic:='0';
	signal cout7 : std_logic:='0';
	signal cout8 : std_logic:='0';
	signal cout9 : std_logic:='0';
	signal cout10 : std_logic:='0';
	signal cout11 : std_logic:='0';
	signal cout12 : std_logic:='0';
	signal cout13 : std_logic:='0';
	signal cout14 : std_logic:='0';
	
begin
	--	Port mapping:
	--		Component instances are mapped to internal signals,
	--		inputs, and outputs.
	--
	-- 	Cascaded Bit Adders
	bit0 : easy1_one_bit_adder
	port map(a(0),b(0),'0',cout0,sum(0));
	bit1 : easy1_one_bit_adder
	port map(a(1),b(1),cout0,cout1,sum(1));
	bit2 : easy1_one_bit_adder
	port map(a(2),b(2),cout1,cout2,sum(2));
	bit3 : easy1_one_bit_adder
	port map(a(3),b(3),cout2,cout3,sum(3));
	bit4 : easy1_one_bit_adder
	port map(a(4),b(4),cout3,cout4,sum(4));
	bit5 : easy1_one_bit_adder
	port map(a(5),b(5),cout4,cout5,sum(5));
	bit6 : easy1_one_bit_adder
	port map(a(6),b(6),cout5,cout6,sum(6));
	bit7 : easy1_one_bit_adder
	port map(a(7),b(7),cout6,cout7,sum(7));
	bit8 : easy1_one_bit_adder
	port map(a(8),b(8),cout7,cout8,sum(8));
	bit9 : easy1_one_bit_adder
	port map(a(9),b(9),cout8,cout9,sum(9));
	bit10 : easy1_one_bit_adder
	port map(a(10),b(10),cout9,cout10,sum(10));
	bit11 : easy1_one_bit_adder
	port map(a(11),b(11),cout10,cout11,sum(11));
	bit12 : easy1_one_bit_adder
	port map(a(12),b(12),cout11,cout12,sum(12));
	bit13 : easy1_one_bit_adder
	port map(a(13),b(13),cout12,cout13,sum(13));
	bit14 : easy1_one_bit_adder
	port map(a(14),b(14),cout13,cout14,sum(14));
	bit15 : easy1_one_bit_adder
	port map(a(15),b(15),cout14,cout,sum(15));
		
	
end arq;
----------------------------------------------------
----------------------------------------------------
